﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        FillVoiceList()
        SetVoiceIndex(0)
        Load_INI()
        InitOldValue()
        SetVoiceParams()
        EventsAreEnabled = True
        lbl_InstalledVoices.Select()
        FastThread_Start()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        FastThread_Abort()
        Save_INI()
        CloseAllSpeechObjects()
    End Sub


    ' ====================================================================
    '  VOICE LIST
    ' ====================================================================
    Private Sub FillVoiceList()
        ListInstalledVoiceNames(list_TTSVoices)
    End Sub

    Private Sub list_TTSVoices_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles list_TTSVoices.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        SetVoiceParams()
    End Sub

    Friend Sub SetVoiceIndex(ByVal index As Int32)
        list_TTSVoices.SelectedItems.Clear()
        If index >= list_TTSVoices.Items.Count Then
            index = list_TTSVoices.Items.Count - 1
        End If
        If index >= 0 Then
            list_TTSVoices.Items(index).Selected = True
        End If
    End Sub

    Friend Function GetVoiceIndex() As Int32
        Return list_TTSVoices.SelectedIndices(0)
    End Function

    ' ====================================================================
    '  VOICE PARAMS
    ' ====================================================================
    Private Sub SetVoiceParams()
        If list_TTSVoices.SelectedItems.Count > 0 Then
            TTS_SetParams(list_TTSVoices.SelectedItems(0).Text, _
                          tbar_Speed.Value, _
                          tbar_Volume.Value)
        End If
    End Sub
    Private Sub tbar_Speed_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbar_Speed.ValueChanged
        SetVoiceParams()
    End Sub
    Private Sub tbar_Volume_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbar_Volume.ValueChanged
        SetVoiceParams()
    End Sub

    ' ====================================================================
    '  SLOT TO TTS - PARAMS
    ' ====================================================================
    Private Sub txt_SlotTTS_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SlotTTS.TextChanged
        InputSlot = CInt(Val(txt_SlotTTS.Text))
        InitOldValue()
    End Sub
    Private Sub txt_RoundToDigits_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_RoundToDigits.TextChanged
        RoundToDigits = CInt(Val(txt_RoundToDigits.Text))
    End Sub
    Private Sub txt_MinChange_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_MinChange.TextChanged
        MinChange = CSng(Val(txt_MinChange.Text))
    End Sub
    Private Sub txt_MinTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_MinTime.TextChanged
        MinTime = CSng(Val(txt_MinTime.Text))
    End Sub

End Class
