﻿
Module Module_FastThread

    Private m_FastThread As Threading.Thread

    Friend Sub FastThread_Start()
        ' --------------------------------------------------------- start the Thread 
        m_FastThread = New Threading.Thread(AddressOf FastThread_Execute)
        ' --------------------------------------------------------- make the thread as background thread.
        m_FastThread.IsBackground = True
        ' --------------------------------------------------------- set the Priority of the thread.
        m_FastThread.Priority = Threading.ThreadPriority.AboveNormal
        ' --------------------------------------------------------- start the thread.
        m_FastThread.Start()
    End Sub

    Friend Sub FastThread_Abort()
        m_FastThread.Abort()
    End Sub

    Private Sub FastThread_Execute()
        Do
            TestSlot()
            Threading.Thread.Sleep(1)
        Loop
    End Sub

    ' ====================================================================
    '  SLOT TO TTS
    ' ====================================================================
    Friend InputSlot As Int32 = 1
    Friend RoundToDigits As Int32 = 9
    Friend MinChange As Double = 0.001
    Friend MinTime As Double = 0.5
    Private OldTime As DateTime = Now
    Private OldValue As Double

    Private Function ReadInputSlot() As Double
        Return RoundToNdigits(Slots.ReadSlot(InputSlot), RoundToDigits)
    End Function

    Friend Sub InitOldValue()
        OldValue = ReadInputSlot()
    End Sub

    Private Sub TestSlot()
        Dim n As Double = ReadInputSlot()
        If Math.Abs(n - OldValue) > MinChange Then
            If Now.Subtract(OldTime).TotalSeconds > MinTime Then
                If TTS.State = Speech.Synthesis.SynthesizerState.Ready Then
                    OldValue = n
                    OldTime = Now
                    SpeakText(n.ToString)
                End If
            End If
        End If
    End Sub

End Module
