﻿
Imports System.Speech.Synthesis

Module Module_Speech

    Friend TTS As SpeechSynthesizer = New SpeechSynthesizer

    Friend Sub CloseAllSpeechObjects()
        TTS_StopAsyncSpeak()
        TTS.Dispose()
    End Sub

    ' ======================================================================================
    '   TEXT TO SPEECH
    ' ======================================================================================
    Friend Sub ListInstalledVoiceNames(ByVal list As ListView)
        list.View = View.Details
        list.FullRowSelect = True
        list.HideSelection = False
        list.Columns.Add("Name", 150, HorizontalAlignment.Left)
        list.Columns.Add("Culture", 50, HorizontalAlignment.Left)
        list.Columns.Add("Gender", 50, HorizontalAlignment.Left)
        list.Columns.Add("Age", 50, HorizontalAlignment.Left)
        list.Columns.Add("Id", 200, HorizontalAlignment.Left)
        For Each voice As InstalledVoice In TTS.GetInstalledVoices()
            Dim listItem As New ListViewItem(voice.VoiceInfo.Name)
            listItem.SubItems.Add(voice.VoiceInfo.Culture.ToString())
            listItem.SubItems.Add(voice.VoiceInfo.Gender.ToString())
            listItem.SubItems.Add(voice.VoiceInfo.Age.ToString())
            listItem.SubItems.Add(voice.VoiceInfo.Id.ToString())
            list.Items.Add(listItem)
        Next
    End Sub

    Friend Sub TTS_SetParams(ByVal voice As String, _
                             ByVal speed As Int32, _
                             ByVal volume As Int32)
        TTS_StopAsyncSpeak()
        TTS.SelectVoice(voice)
        TTS.Rate = speed
        TTS.Volume = volume
    End Sub

    Friend Sub SpeakText(ByVal text As String)
        TTS.SpeakAsync(text)
    End Sub

    Friend Sub TTS_StopAsyncSpeak()
        TTS.SpeakAsyncCancelAll()
        Do
            Threading.Thread.Sleep(10)
        Loop Until TTS.State = SynthesizerState.Ready
    End Sub

End Module
